#Embedded file name: D:\Download\plugin.py
from Components.ActionMap import *
from Components.Label import Label
from Components.MenuList import MenuList
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.config import config
from Components.GUIComponent import GUIComponent
from enigma import ePicLoad
from Tools.LoadPixmap import LoadPixmap
from Components.Pixmap import Pixmap
from Components.AVSwitch import AVSwitch
from Screens.InfoBar import MoviePlayer
from Components.PluginComponent import plugins
from Components.Button import Button
from Screens.Screen import Screen
from Plugins.Plugin import PluginDescriptor
from twisted.web.client import getPage
from twisted.web.client import downloadPage
from Components.ServicePosition import ServicePositionGauge
from Tools.NumericalTextInput import NumericalTextInput
from Components.ConfigList import *
from Components.config import *
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.config import config, ConfigSubsection, ConfigText, getConfigListEntry, ConfigSelection
from Screens.HelpMenu import HelpableScreen
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from enigma import eListboxPythonMultiContent, eListbox, gFont, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, loadPNG, RT_WRAP, eServiceReference, getDesktop, loadJPG, eTPM
from Tools.Directories import pathExists, fileExists, SCOPE_SKIN_IMAGE, resolveFilename
import sys, os, base64, re, time
from datetime import datetime
from twisted.web import client, error as weberror
from twisted.internet import reactor
from twisted.internet import defer
from urllib import quote, urlencode
from time import strptime, mktime
import sha, cookielib, urllib2, urllib, shutil
import xml.dom.minidom
if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/JobManager/plugin.pyo'):
    from Plugins.Extensions.JobManager.plugin import *
    JobManagerInstalled = True
else:
    JobManagerInstalled = False
config.plugins.burns = ConfigSubsection()
config.plugins.burns.cover = ConfigSelection(default='0', choices=[('1', _('AN')), ('0', _('AUS'))])
config.plugins.burns.updateonstart = ConfigSelection(default='0', choices=[('1', _('AN')), ('0', _('AUS'))])

class myTVlist(MenuList):

    def __init__(self, list):
        MenuList.__init__(self, list, False, eListboxPythonMultiContent)
        self.l.setFont(0, gFont('Regular', 14))
        self.l.setFont(1, gFont('Regular', 16))
        self.l.setFont(2, gFont('Regular', 18))
        self.l.setFont(3, gFont('Regular', 17))
        self.l.setFont(4, gFont('Regular', 22))
        self.l.setFont(5, gFont('Regular', 24))
        self.l.setFont(6, gFont('Regular', 26))
        self.l.setFont(7, gFont('Regular', 20))


class burns_setup(Screen, ConfigListScreen):
    skin = '\n\t\t<screen position="center,center" size="400,100" title="Setup">\n\t\t\t<widget name="config" position="10,0" size="370,100" scrollbarMode="showOnDemand" />\n\t\t</screen>'

    def __init__(self, session, plugin_path):
        Screen.__init__(self, session)
        self.plugin_path = plugin_path
        self.skin_path = plugin_path
        self.session = session
        self.list = []
        ConfigListScreen.__init__(self, self.list)
        self.list.append(getConfigListEntry('Show Cover:', config.plugins.burns.cover))
        self.list.append(getConfigListEntry('Check for New EPs on Startup:', config.plugins.burns.updateonstart))
        self['config'].setList(self.list)
        self['setupActions'] = ActionMap(['SetupActions'], {'ok': self.saveConfig,
         'cancel': self.exit}, -1)

    def saveConfig(self):
        print 'save'
        for x in self['config'].list:
            x[1].save()

        self.close('True')

    def exit(self):
        print 'closen'
        self.close('False')


class burns(Screen, ConfigListScreen, NumericalTextInput):
    skin = '\n\t\t<screen position="center,center" size="460,460" title="Burning-seri.es Streamer v0.6">\n\t\t\t<widget name="main" position="0,0" size="460,85" pixmap="~/images/main.png" alphatest="blend" />\n\t\t\t<widget name="myTVmenulist" position="0,90" size="460,286" transparent="1" scrollbarMode="showOnDemand" />\n\t\t\t<widget name="info" position="45,385" size="450,24" zPosition="0" font="Regular;22" transparent="1" foregroundColor="yellow" />\n\t\t\t<ePixmap position="10,387" size="16,16" pixmap="~/images/info.png" alphatest="blend" />\n\t\t\t<widget name="ButtonRed" position="20,444" pixmap="~/images/red.png" zPosition="10" size="90,8" transparent="1" alphatest="on" />\n\t\t\t<widget name="TextRed" position="20,420" size="90,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />\n\t\t\t<widget name="ButtonGreen" position="130,444" pixmap="~/images/green.png" zPosition="10" size="90,8" transparent="1" alphatest="on" />\n\t\t\t<widget name="TextGreen" position="130,420" size="90,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />\n\t\t\t<widget name="ButtonYellow" position="240,444" pixmap="~/images/yellow.png" zPosition="10" size="90,8" transparent="1" alphatest="on" />\n\t\t\t<widget name="TextYellow" position="240,420" size="90,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />\n\t\t\t<widget name="ButtonBlue" position="350,444" pixmap="~/images/blue.png" zPosition="10" size="90,8" transparent="1" alphatest="on" />\n\t\t\t<widget name="TextBlue" position="350,422" size="90,24" valign="center" halign="center" zPosition="10" font="Regular;18" transparent="1" />\n\t\t</screen>'

    def __init__(self, session, plugin_path):
        Screen.__init__(self, session)
        self.plugin_path = plugin_path
        self.skin_path = plugin_path
        self.session = session
        NumericalTextInput.__init__(self)
        self.setUseableChars(u'1234567890abcdefghijklmnopqrstuvwxyz')
        self['info'] = Label('')
        self['main'] = Pixmap()
        self['ButtonRed'] = Pixmap()
        self['TextRed'] = Label('Delete')
        self['ButtonGreen'] = Pixmap()
        self['TextGreen'] = Label('A-Z')
        self['ButtonYellow'] = Pixmap()
        self['TextYellow'] = Label('Jobs')
        self['ButtonBlue'] = Pixmap()
        self['TextBlue'] = Label('Download')
        self['TextBlue'].hide()
        self.myTVmenulist = []
        self['myTVmenulist'] = myTVlist([])
        self['myTVmenulist'].selectionEnabled(0)
        self.show_cover = config.plugins.burns.cover.value
        self.check_on_startup = config.plugins.burns.updateonstart.value
        self.ok_info = 'main'
        self.show_true = False
        self.showinfo_an = False
        self.update_check = False
        self.dnfile = False
        self.last_ep_watched = 1
        self['shortcuts'] = NumberActionMap(['ShortcutActions',
         'WizardActions',
         'NumberActions',
         'InputActions',
         'InputAsciiActions',
         'KeyboardInputActions'], {'gotAsciiCode': self.keyGotAscii,
         '1': self.keyNumberGlobal,
         '2': self.keyNumberGlobal,
         '3': self.keyNumberGlobal,
         '4': self.keyNumberGlobal,
         '5': self.keyNumberGlobal,
         '6': self.keyNumberGlobal,
         '7': self.keyNumberGlobal,
         '8': self.keyNumberGlobal,
         '9': self.keyNumberGlobal,
         '0': self.keyNumberGlobal}, -1)
        self['OkCancelActions'] = HelpableActionMap(self, 'OkCancelActions', {'cancel': self.exit,
         'ok': self.ok}, -1)
        self['EPGSelectActions'] = HelpableActionMap(self, 'EPGSelectActions', {'input_date_time': self.burns_config,
         'red': self.fav_del,
         'blue': self.dnitnow,
         'timerAdd': self.read_list,
         'yellow': self.jobix,
         'info': self.update}, -1)
        self['InfobarActions'] = HelpableActionMap(self, 'InfobarActions', {'showMovies': self.jobix}, -1)
        rcinput = eRCInput.getInstance()
        rcinput.setKeyboardMode(rcinput.kmAscii)
        self.onLayoutFinish.append(self.favourites)

    def jobix(self):
        if JobManagerInstalled:
            self.session.open(JobManagerFrontEnd)

    def burns_config(self):
        self.session.openWithCallback(self.danach, burns_setup, plugin_path)

    def danach(self, data):
        if data:
            self.show_cover = config.plugins.burns.cover.value
            self.check_on_startup = config.plugins.burns.updateonstart.value
            self.close(self.session, 'restart')

    def update(self):
        self.counting = 0
        self.update_liste = []
        self.favouriten_list = []
        if self.show_cover == '1' and self.showinfo_an:
            self.showinfo_an = False
            self['myTVmenulist'].onSelectionChanged.remove(self.showinfo)
        if not fileExists(self.plugin_path + '/updates'):
            os.system('touch ' + self.plugin_path + '/updates')
        leer = os.path.getsize(self.plugin_path + '/updates')
        if leer == 0:
            self['info'].setText('Please ADD a Serie.. Press GREEN..')
            print '[BS] updates file is empty.. Press INFO Button.'
        else:
            self.updates_read = open(self.plugin_path + '/updates', 'r')
            for lines in sorted(self.updates_read.readlines()):
                line = re.findall('"(.*?)" "(.*?)"', lines)
                if line:
                    ep, url = line[0]
                    self.update_liste.append((ep, url))

            self.updates_read.close()
        if fileExists(self.plugin_path + '/favorites'):
            leer = os.path.getsize(self.plugin_path + '/favorites')
            if leer == 0:
                print '[BS] favorites file is empty.. Press INFO Button.'
                self['info'].setText('Please ADD a Serie.. Press GREEN..')
            else:
                url_list = []
                self['info'].setText('Updating Series..')
                favorites_read = open(self.plugin_path + '/favorites', 'r')
                for lines in sorted(favorites_read.readlines()):
                    line = re.findall('"(.*?)" "(.*?)"', lines)
                    if line:
                        serien_name, url = line[0]
                        print serien_name, url
                        url_list.append((serien_name, url))

                if len(url_list) != 0:
                    self.count = len(url_list)
                    ds = defer.DeferredSemaphore(tokens=1)
                    downloads = [ ds.run(self.download, item[1]).addCallback(self.load_data_new, item[0], item[1]).addErrback(self.errorload) for item in url_list ]
                    finished = defer.DeferredList(downloads).addErrback(self.errorload)
        else:
            self['info'].setText('Please ADD a Serie.. Press GREEN..')

    def download(self, item):
        return getPage(item)

    def load_data_new(self, data, serien_name, url):
        link_staffel = re.findall('<a href="serie/.*?/\\d+">(\\d+)</a></li>', data, re.S)
        print '[BS] Update: %s Last Staffel: %s' % (serien_name, link_staffel[-1])
        url_new = '%s/%s' % (url, link_staffel[-1])
        getPage(url_new, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.updaten, serien_name, url).addErrback(self.errorload)

    def updaten(self, data, serien_name, url):
        check_new = False
        updates_read = open(self.plugin_path + '/updates', 'a')
        infos = re.findall('<tr>.*?<td>(\\d+)</td>.*?<td><a href="serie/(.*?)">', data, re.S)
        if infos:
            for each in infos:
                ep, url2 = each
                if each not in self.update_liste:
                    print '[BS] Add: %s - %s' % (ep, url2)
                    updates_read.write('"%s" "%s"\n' % (ep, url2))
                    check_new = True

        updates_read.close()
        if check_new:
            self.favouriten_list.append(self.show_serien_update(serien_name, url, '1'))
        else:
            self.favouriten_list.append(self.show_serien_update(serien_name, url, '0'))
        self['myTVmenulist'].l.setList(self.favouriten_list)
        self.counting += 1
        self['info'].setText('Updating Series.. %s/%s' % (self.counting, self.count))
        if self.count == self.counting:
            self['info'].setText('Update Series done.')
            if self.show_cover == '1' and not self.showinfo_an:
                self.showinfo_an = True
                self['myTVmenulist'].onSelectionChanged.append(self.showinfo)

    def favourites(self):
        print 'showinfo:', self.showinfo_an
        self.ok_info = 'main'
        self.favouriten_list = []
        if fileExists(self.plugin_path + '/favorites'):
            not_empty = False
            leer = os.path.getsize(self.plugin_path + '/favorites')
            if not leer == 0:
                if self.check_on_startup == '1' and not self.update_check:
                    print '[BS] Check for new EPs on Startup..'
                    self.update_check = True
                    self.update()
                else:
                    favorites_read = open(self.plugin_path + '/favorites', 'r')
                    for lines in sorted(favorites_read.readlines()):
                        line = re.findall('"(.*?)" "(.*?)"', lines)
                        if line:
                            self['info'].setText('Show favourite Series.')
                            serien_name, url = line[0]
                            print serien_name, url
                            self.favouriten_list.append(self.show_serien(serien_name, url))
                            self['myTVmenulist'].l.setList(self.favouriten_list)

                    favorites_read.close()
                    not_empty = True
                if self.show_cover == '1' and not_empty and not self.showinfo_an:
                    self.showinfo_an = True
                    self['myTVmenulist'].onSelectionChanged.append(self.showinfo)
            else:
                self.showinfo_an = False
                print '[BS] favorites file is empty.'
                self['info'].setText('Please ADD a Serie.. Press GREEN..')
                main_poster = self.plugin_path + '/images/main.png'
                self.poster_resize(main_poster)
                self['myTVmenulist'].l.setList(self.favouriten_list)
        else:
            self.showinfo_an = False
            print '[BS] favorites file nicht vorhanden.'
            self['info'].setText('Please ADD a Serie.. Press GREEN..')
            self['myTVmenulist'].l.setList(self.favouriten_list)

    def showinfo(self):
        if self.ok_info == 'main' and self.show_cover == '1' and self.showinfo_an:
            item = self['myTVmenulist'].getCurrent()
            jpg_name = item[0][1].replace('http://bs.to/serie/', '')
            if not os.path.exists('/tmp/burnseries'):
                os.mkdir('/tmp/burnseries', 509)
            jpg_store = '/tmp/burnseries/%s' % jpg_name
            if fileExists(jpg_store):
                self.poster_resize(jpg_store)
            else:
                name = quote(item[0][0])
                tvdb_url = 'http://www.thetvdb.com/api/GetSeries.php?seriesname=%s&language=de' % name.replace(',', '').replace(':', '')
                getPage(tvdb_url, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.poster_data, jpg_store).addErrback(self.errorload)

    def poster_data(self, data, jpg_store):
        if not os.path.exists('/tmp/burnseries'):
            os.mkdir('/tmp/burnseries', 509)
        poster_link = re.findall('<seriesid>(.*?)</seriesid>', data, re.S)
        if len(poster_link) > 0:
            url = 'http://thetvdb.com/api/4144331619000000/series/%s/banners.xml' % poster_link[0]
            downloadPage(url, jpg_store).addCallback(self.downloadPic, jpg_store).addErrback(self.errorload)
        else:
            main_poster = self.plugin_path + '/images/main.png'
            self.poster_resize(main_poster)

    def downloadPic(self, data, jpg_store):
        if fileExists(jpg_store):
            self.poster_resize(jpg_store)

    def poster_resize(self, poster_path):
        self['main'].instance.setPixmap(None)
        self['main'].hide()
        sc = AVSwitch().getFramebufferScale()
        self.picload = ePicLoad()
        size = self['main'].instance.size()
        self.picload.setPara((size.width(),
         size.height(),
         sc[0],
         sc[1],
         False,
         1,
         '#00000000'))
        if self.picload.startDecode(poster_path, 0, 0, False) == 0:
            ptr = self.picload.getData()
            if ptr != None:
                self['main'].instance.setPixmap(ptr)
                self['main'].show()

    def keyNumberGlobal(self, val):
        key = self.getKey(val)
        if key is not None:
            keyvalue = key.encode('utf-8')
            if len(keyvalue) == 1:
                self.setNextIdx(keyvalue[0])

    def keyGotAscii(self):
        keyvalue = unichr(getPrevAsciiCode()).encode('utf-8')
        if len(keyvalue) == 1:
            self.setNextIdx(keyvalue[0])

    def setNextIdx(self, char):
        if char in ('0', '1', 'a'):
            self['myTVmenulist'].moveToIndex(0)
        else:
            idx = self.getNextIdx(char)
            if idx and idx <= len(self.myTVmenulist):
                self['myTVmenulist'].moveToIndex(idx)

    def getNextIdx(self, char):
        idx = 0
        for i in self.myTVmenulist:
            if i[0][0][0].lower() == char:
                return idx
            idx += 1

    def read_list(self):
        if self.ok_info == 'main':
            self.ok_info = 'ADD'
            self['info'].setText('Open burning-seri.es..')
            url = 'http://bs.to/serie-alphabet'
            getPage(url, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.list_data).addErrback(self.errorload)

    def list_data(self, data):
        if self.show_cover == '1' and self.showinfo_an:
            print '[BS] showinfo removed.'
            self.showinfo_an = False
            self['myTVmenulist'].onSelectionChanged.remove(self.showinfo)
        serien_raw = re.findall("<ul id='serSeries'>(.*?)</ul>", data, re.S)
        if serien_raw:
            self['info'].setText('Read burning-seri.es..')
            serien = re.findall('<li><a href="(.*?)">(.*?)</a></li>', serien_raw[0], re.S)
            if serien:
                for each in serien:
                    url, title = each
                    url = 'http://bs.to/%s' % url
                    self.myTVmenulist.append(self.show_serien(title.replace('&#039;', "'").replace('&amp;', '&'), url))
                    self['myTVmenulist'].l.setList(self.myTVmenulist)
                    self['myTVmenulist'].l.setItemHeight(22)

            else:
                self['info'].setText('Fehler, konnte keine serien finden.')
        else:
            self['info'].setText('Fehler, konnte keine serien finden.')

    def show_serien_update(self, title, url, maybe_new):
        res = [(title, url, maybe_new)]
        tv = self.plugin_path + '/images/tv.png'
        if fileExists(tv):
            res.append(MultiContentEntryPixmapAlphaTest(pos=(7, 3), size=(16, 16), png=loadPNG(tv)))
        res.append(MultiContentEntryText(pos=(30, 0), size=(330, 22), font=7, text=title, flags=RT_HALIGN_LEFT))
        new = 'NEW'
        if maybe_new == '1':
            res.append(MultiContentEntryText(pos=(350, 0), size=(100, 22), font=7, text=new, color=13369344, flags=RT_HALIGN_LEFT))
        return res

    def show_serien(self, title, url):
        res = [(title, url)]
        tv = self.plugin_path + '/images/tv.png'
        if fileExists(tv):
            res.append(MultiContentEntryPixmapAlphaTest(pos=(7, 3), size=(16, 16), png=loadPNG(tv)))
        res.append(MultiContentEntryText(pos=(30, 0), size=(330, 22), font=7, text=title, flags=RT_HALIGN_LEFT))
        return res

    def ep_data(self, data):
        self.watched_liste = []
        self.mark_last_watched = []
        if not fileExists(self.plugin_path + '/watched'):
            os.system('touch ' + self.plugin_path + '/watched')
        if fileExists(self.plugin_path + '/watched'):
            leer = os.path.getsize(self.plugin_path + '/watched')
            if not leer == 0:
                self.updates_read = open(self.plugin_path + '/watched', 'r')
                for lines in sorted(self.updates_read.readlines()):
                    line = re.findall('"(.*?)" "(.*?)"', lines)
                    if line:
                        s_name, sp_name = line[0]
                        self.watched_liste.append('%s %s' % (s_name, sp_name))

                self.updates_read.close()
        infos = re.findall('<tr>.*?<td>(\\d+)</td>.*?<td><a href="serie/(.*?)">', data, re.S)
        if infos:
            self['info'].setText('Zeige Episoden an.')
            self.ep_list = []
            for each in infos:
                print each
                ep, url = each
                print self.staffel_name, ep
                self.ep_dupe = 'S%sE%s' % (self.staffel_name, ep)
                print self.ep_dupe
                title = re.findall('/\\d+/\\d+-(.*[0-9a-z]+)', url, re.S | re.I)
                url = 'http://bs.to/serie/%s' % url
                check = '%s %s' % (self.serie_burns_name, self.ep_dupe)
                if check in self.watched_liste:
                    self.ep_list.append(self.show_ep(self.ep_dupe, title[0].replace('-', ' '), url, '1'))
                    self.mark_last_watched.append(self.ep_dupe)
                    print 'dupe', check
                else:
                    print 'undupe', check
                    self.ep_list.append(self.show_ep(self.ep_dupe, title[0].replace('-', ' '), url, '0'))

            if len(self.mark_last_watched) != 0:
                print '[BS] Last watched EP: %s - Total ep watched: %s' % (self.mark_last_watched[-1], len(self.mark_last_watched))
                counting_watched = 0
                for each in self.ep_list:
                    counting_watched += 1
                    print self.mark_last_watched[-1], each[0][0]
                    if self.mark_last_watched[-1] == each[0][0]:
                        print '[BS] found last ep:', int(counting_watched) - 1
                        counting_watched = int(counting_watched) - 1
                        break

                self['myTVmenulist'].l.setList(self.ep_list)
                self['myTVmenulist'].l.setItemHeight(22)
                self['myTVmenulist'].moveToIndex(int(counting_watched))
                self.ok_info = 'ep'
            else:
                count_all = len(self.ep_list) - 1
                self['myTVmenulist'].l.setList(self.ep_list)
                self['myTVmenulist'].l.setItemHeight(22)
                self['myTVmenulist'].moveToIndex(int(count_all))
                self.ok_info = 'ep'
        else:
            self['info'].setText('Fehler, konnte keine episoden finden.')

    def show_ep(self, ep, title, url, watched):
        res = [(ep,
          title,
          url,
          watched)]
        watch = self.plugin_path + '/images/watched.png'
        if watched == '1' and fileExists(watch):
            res.append(MultiContentEntryPixmapAlphaTest(pos=(10, 3), size=(16, 16), png=loadPNG(watch)))
        res.append(MultiContentEntryText(pos=(40, 0), size=(70, 22), font=7, text=ep, flags=RT_HALIGN_LEFT))
        res.append(MultiContentEntryText(pos=(120, 0), size=(355, 22), font=7, text=title, flags=RT_HALIGN_LEFT))
        return res

    def fav_del(self):
        if self.ok_info == 'main':
            serien_daten = self['myTVmenulist'].getCurrent()
            if serien_daten:
                sj_title = serien_daten[0][0]
                sj_url = serien_daten[0][1]
                print sj_title, sj_url
                if fileExists(self.plugin_path + '/favorites'):
                    inp = open(self.plugin_path + '/favorites', 'r')
                    create = open(self.plugin_path + '/favorites.tmp', 'a')
                    create.truncate(0)
                    for lines in inp.readlines():
                        line = re.findall('"(.*?)" "(.*?)"', lines)
                        if line:
                            if not sj_title == line[0][0]:
                                create.write('"%s" "%s"\n' % (line[0][0], line[0][1]))
                            else:
                                print '[BS] del %s' % sj_title

                    create.close()
                    shutil.move(self.plugin_path + '/favorites.tmp', self.plugin_path + '/favorites')
                    self.ok_info = 'main'
                    self.favourites()
            else:
                self['info'].setText('Please ADD a Serie.. Press GREEN..')
                print '[BS] Favouriten empty..'

    def errorload(self, error):
        print '[BS]:', error

    def ok(self):
        print 'self.ok_info:', self.ok_info
        if self.ok_info == 'main':
            try:
                print '[BS] showinfo: %s' % self.showinfo_an
                if self.show_cover == '1' and self.showinfo_an:
                    self.showinfo_an = False
                    self['myTVmenulist'].onSelectionChanged.remove(self.showinfo)
                item = self['myTVmenulist'].getCurrent()
                if item:
                    self['TextGreen'].hide()
                    self['TextRed'].hide()
                    url = item[0][1]
                    self.serie_burns_name = item[0][0]
                    self.serie_url = url
                    getPage(url, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.staffeln_data).addErrback(self.errorload)
            except:
                print '[BS] OK Pressed with error..'

        elif self.ok_info == 'staffeln':
            item = self['myTVmenulist'].getCurrent()
            print item
            self.staffel_name = item[0][1]
            self.serie_url2 = '%s/%s' % (self.serie_url, self.staffel_name)
            print self.serie_url
            getPage(self.serie_url2, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.ep_data).addErrback(self.errorload)
        elif self.ok_info == 'ep':
            item = self['myTVmenulist'].getCurrent()
            self['TextBlue'].show()
            self.ep_name = item[0][0]
            url = item[0][2]
            getPage(url, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.streamer_data).addErrback(self.errorload)
        elif self.ok_info == 'streams':
            self.dnfile = False
            item = self['myTVmenulist'].getCurrent()
            url = item[0][1]
            getPage(url, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.get_streamlink).addErrback(self.errorload)
        elif self.ok_info == 'ADD':
            item = self['myTVmenulist'].getCurrent()
            if item:
                serien_name = item[0][0]
                url = item[0][1]
                if not fileExists(self.plugin_path + '/favorites'):
                    os.system('touch ' + self.plugin_path + '/favorites')
                if fileExists(self.plugin_path + '/favorites'):
                    favorites_read = open(self.plugin_path + '/favorites', 'a')
                    favorites_read.write('"%s" "%s"\n' % (serien_name, url))
                    favorites_read.close()
                    message = self.session.open(MessageBox, _('Serie ' + serien_name + ' added to favourites'), MessageBox.TYPE_INFO, timeout=3)
                    print '[BS]: added', serien_name, url

    def get_streamlink(self, data):
        if re.match('.*?http://www.putlocker.com/embed/', data, re.S):
            link = re.findall("(http://www.putlocker.com/embed/.*?)'", data, re.S)
            if link:
                getPage(link[0], headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.streamPutlockerSockshare, 'putlocker').addErrback(self.errorload)
        elif re.match('.*?http://www.sockshare.com/embed/', data, re.S):
            link = re.findall("(http://www.sockshare.com/embed/.*?)'", data, re.S)
            if link:
                getPage(link[0], headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.streamPutlockerSockshare, 'sockshare').addErrback(self.errorload)
        elif re.match('.*?http://streamcloud.eu/', data, re.S):
            link = re.findall("(http://streamcloud.eu/.*?)'", data, re.S)
            if link:
                getPage(link[0], headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.streamcloud).addErrback(self.errorload)
        else:
            self['info'].setText('Konnte keinen stream finden.')

    def stream_not_found(self):
        message = self.session.open(MessageBox, _('Stream not found, try another Stream Hoster.'), MessageBox.TYPE_INFO, timeout=3)

    def error(self, info):
        data = str(info).split(None, 1)
        error = data[0].replace('[', '') + ' ' + data[1].replace(']', '')
        message = self.session.open(MessageBox, error, MessageBox.TYPE_INFO, timeout=5)

    def streamPutlockerSockshare(self, data, provider):
        uid = '<a href="/file/(.*?)"'
        match = re.findall(uid, data)
        if len(match) > 0:
            url = 'http://www.%s.com/embed/%s' % (provider, match[0])
            enter = re.findall('<input type="hidden" value="(.*?)" name="fuck_you">', data)
            post_data = urlencode({'fuck_you': enter[0],
             'confirm': 'Close Ad and Watch as Free User'})
            values = {'fuck_you': enter[0],
             'confirm': 'Close+Ad+and+Watch+as+Free+User'}
            user_agent = 'Mozilla/5.0 (X11; Linux x86_64; rv:13.0) Gecko/20100101 Firefox/13.0'
            headers = {'User-Agent': user_agent}
            cookiejar = cookielib.LWPCookieJar()
            cookiejar = urllib2.HTTPCookieProcessor(cookiejar)
            opener = urllib2.build_opener(cookiejar)
            urllib2.install_opener(opener)
            data = urlencode(values)
            req = urllib2.Request(url, data, headers)
            try:
                response = urllib2.urlopen(req)
            except urllib2.URLError as e:
                self.error(e)
            except urllib2.HTTPError as e:
                self.error(e)
            except urllib2.IOError as e:
                self.error(e)

            tmp = response.readlines()
            link = (False, '')
            for each in tmp:
                if each.find('playlist') != -1:
                    link = (True, each.replace("playlist: '", '').replace("',", '').strip())

            if link[0]:
                url = 'http://www.%s.com%s' % (provider, link[1])
                nexturl = urllib2.Request(url)
                nexturl.add_header('User-Agent', user_agent)
                try:
                    response = urllib2.urlopen(nexturl)
                except urllib2.URLError as e:
                    self.error(e)
                except urllib2.HTTPError as e:
                    self.error(e)
                except urllib2.IOError as e:
                    self.error(e)

                link = response.read()
                cfg = xml.dom.minidom.parseString(link)
                content = cfg.getElementsByTagName('media:content')
                if content[0].hasAttributes():
                    streamurl = content[0].getAttribute('url').encode('utf-8')
                    if streamurl.find('.flv') != -1:
                        print streamurl
                        self.play_movie(streamurl)
                    else:
                        streamurl = content[1].getAttribute('url').encode('utf-8')
                        if streamurl.find('.flv') != -1:
                            print streamurl
                            self.play_movie(streamurl)
                else:
                    print '[Burning-Series.to Streamer v0.6] XML Playlist error'
                    self.stream_not_found()
            else:
                self.stream_not_found()
        else:
            self.stream_not_found()

    def streamcloud(self, data):
        id = re.findall('<input type="hidden" name="id".*?value="(.*?)">', data)
        fname = re.findall('<input type="hidden" name="fname".*?alue="(.*?)">', data)
        hash = re.findall('<input type="hidden" name="hash" value="(.*?)">', data)
        if id and fname and hash:
            url = 'http://streamcloud.eu/%s' % id[0]
            post_data = urllib.urlencode({'op': 'download2',
             'usr_login': '',
             'id': id[0],
             'fname': fname[0],
             'referer': '',
             'hash': hash[0],
             'imhuman': 'Weiter+zum+Video'})
            getPage(url, method='POST', postdata=post_data, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.streamcloud_data).addErrback(self.errorload)
        else:
            self.stream_not_found()

    def streamcloud_data(self, data):
        stream_url = re.findall('file: "(.*?)"', data)
        if stream_url:
            print stream_url
            self.play_movie(stream_url[0])
        else:
            self.stream_not_found()

    def dnitnow(self):
        if JobManagerInstalled and self.ok_info == 'streams':
            print '[BS] set download value.'
            self.dnfile = True
            item = self['myTVmenulist'].getCurrent()
            if item:
                url = item[0][1]
                getPage(url, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.get_streamlink).addErrback(self.errorload)

    def play_movie(self, link):
        self.filmname = '%s - %s' % (self.serie_burns_name, self.ep_name)
        print self.filmname
        if not fileExists(self.plugin_path + '/watched'):
            os.system('touch ' + self.plugin_path + '/watched')
        self.update_liste = []
        leer = os.path.getsize(self.plugin_path + '/watched')
        if not leer == 0:
            self.updates_read = open(self.plugin_path + '/watched', 'r')
            for lines in sorted(self.updates_read.readlines()):
                line = re.findall('"(.*?)" "(.*?)"', lines)
                if line:
                    s_name, sp_name = line[0]
                    print s_name, sp_name
                    self.update_liste.append('%s %s' % (s_name, sp_name))

            self.updates_read.close()
            updates_read = open(self.plugin_path + '/watched', 'a')
            check = '%s %s' % (self.serie_burns_name, self.ep_name)
            if check not in self.update_liste:
                print '[KX] update add: %s - %s' % (self.serie_burns_name, self.ep_name)
                updates_read.write('"%s" "%s"\n' % (self.serie_burns_name, self.ep_name))
                updates_read.close()
            else:
                print '[BS] dupe %s - %s' % (self.serie_burns_name, self.ep_name)
        else:
            updates_read = open(self.plugin_path + '/watched', 'a')
            print '[BS] update add: %s - %s' % (self.serie_burns_name, self.ep_name)
            updates_read.write('"%s" "%s"\n' % (self.serie_burns_name, self.ep_name))
            updates_read.close()
        print '[BS] play %s' % link
        if not self.dnfile:
            sref = eServiceReference(4097, 0, link)
            self.session.open(MoviePlayer, sref)
        else:
            self.dnfile = False
            self.currentDownload = ''
            self.currentDownload = jm.addJobToList(link, self.filmname)
            jm.startDownload(self.currentDownload)
            message = self.session.open(MessageBox, _('Download has been started. Please check progress in JobManager with PVR Button.'), MessageBox.TYPE_INFO, timeout=5)

    def streamer_data(self, data):
        streams_raw = re.findall('<h3>Hoster dieser Episode</h3>(.*?)</ul>', data, re.S)
        if streams_raw:
            streams = re.findall('<li><a.*?href="(serie/.*?)"><span.*?class="icon.(.*?)"></span>', streams_raw[0], re.S)
            if streams:
                self.stream_list = []
                self['info'].setText('Zeige Streams an.')
                for each in streams:
                    url, hoster_name = each
                    print hoster_name, url
                    url = 'http://bs.to/%s' % url
                    if re.match('.*?(Sockshare|streamcloud|Putlocker)', hoster_name, re.S | re.I):
                        self.stream_list.append(self.show_streams(hoster_name, url))

                if len(self.stream_list) > 0:
                    self['myTVmenulist'].l.setList(self.stream_list)
                    self['myTVmenulist'].l.setItemHeight(22)
                    self.ok_info = 'streams'
                else:
                    self['info'].setText('Fehler, konnte keine streams finden.')
            else:
                self['info'].setText('Fehler, konnte keine streams finden.')
        else:
            self['info'].setText('Fehler, konnte keine streams finden.')

    def show_streams(self, hoster_name, url):
        res = [(hoster_name, url)]
        res.append(MultiContentEntryText(pos=(10, 0), size=(200, 22), font=7, text=hoster_name, flags=RT_HALIGN_LEFT))
        return res

    def staffeln_data(self, data):
        link_staffel = re.findall('<a href="serie/.*?/\\d+">(\\d+)</a></li>', data, re.S)
        if link_staffel:
            self['info'].setText('Zeige Staffeln an.')
            self.staffeln = []
            for each in link_staffel:
                staffel_name = 'Staffel %s' % each
                self.staffeln.append(self.show_staffeln(staffel_name, each))
                self['myTVmenulist'].l.setList(self.staffeln)
                self['myTVmenulist'].l.setItemHeight(22)

            self.ok_info = 'staffeln'
        else:
            self['info'].setText('Fehler, konnte keine staffeln finden.')

    def show_staffeln(self, staffel_name, id):
        res = [(staffel_name, id)]
        res.append(MultiContentEntryText(pos=(10, 0), size=(200, 22), font=7, text=staffel_name, flags=RT_HALIGN_LEFT))
        return res

    def exit(self):
        print '[BS]:', self.ok_info
        if self.ok_info == 'main':
            if self.show_cover == '1' and self.showinfo_an:
                self.showinfo_an = False
                self['myTVmenulist'].onSelectionChanged.remove(self.showinfo)
            self.close(self.session, 'exit')
        elif self.ok_info == 'staffeln':
            self['info'].setText('Zeige Serien an.')
            self.ok_info = 'main'
            self['TextRed'].show()
            self['TextGreen'].show()
            self.favourites()
        elif self.ok_info == 'ep':
            self['info'].setText('Zeige Staffeln an.')
            self.ok_info = 'staffeln'
            self['TextBlue'].hide()
            self['TextRed'].hide()
            self['TextGreen'].hide()
            self['myTVmenulist'].l.setList(self.staffeln)
            self['myTVmenulist'].l.setItemHeight(22)
        elif self.ok_info == 'streams':
            self['info'].setText('Zeige Episoden an.')
            self.ok_info = 'ep'
            self['TextBlue'].hide()
            self['TextRed'].hide()
            self['TextGreen'].hide()
            getPage(self.serie_url2, headers={'Content-Type': 'application/x-www-form-urlencoded'}).addCallback(self.ep_data).addErrback(self.errorload)
        elif self.ok_info == 'ADD':
            self.ok_info = 'main'
            self.favourites()


def main(session, **kwargs):
    session.openWithCallback(closen, burns, plugin_path)


def closen(session, result):
    if result == 'restart':
        session.openWithCallback(closen, burns, plugin_path)
    elif result == 'exit':
        pass


def Plugins(path, **kwargs):
    global plugin_path
    plugin_path = path
    return [PluginDescriptor(name='Burning Series', description='Stream your favourite series', where=[PluginDescriptor.WHERE_EXTENSIONSMENU], fnc=main), PluginDescriptor(name='Burning Series', description='Stream your favourite series', where=[PluginDescriptor.WHERE_PLUGINMENU], fnc=main, icon='plugin.png')]